#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/AcknowledgeMessageRequest.h>
#include <tencentcloud/tdmq/v20200217/model/AcknowledgeMessageResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**、
 * 确认消息示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 获取tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    AcknowledgeMessageRequest req = AcknowledgeMessageRequest();
    // 确认消息的id
    req.SetMessageId("69932384:0:1:0");
    // 设置topic名称, 格式为：集群（租户）ID/命名空间/Topic名称
    req.SetAckTopic("pulsar-xxx/cpp_http/topic1");
    // 设置订阅信息
    req.SetSubName("sub");
    // 确认消息
    auto outcome = client.AcknowledgeMessage(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    AcknowledgeMessageResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}