#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/ReceiveMessageRequest.h>
#include <tencentcloud/tdmq/v20200217/model/ReceiveMessageResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 消费消息示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    ReceiveMessageRequest req = ReceiveMessageRequest();
    // 设置topic名称, 格式为：集群（租户）ID/命名空间/Topic名称
    req.SetTopic("pulsar-xxx/cpp_http/topic1");
    // 设置订阅名称
    req.SetSubscriptionName("sub");
    // consumer接收的消息会首先存储到receiverQueueSize这个队列中，用作调优接收消息的速率
    req.SetReceiverQueueSize(10);
    // 设置consumer初始接收消息的位置，可选参数为：Earliest, Latest
    req.SetSubInitialPosition("Latest");

    // 接收消息
    auto outcome = client.ReceiveMessage(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    ReceiveMessageResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}