#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/SendBatchMessagesRequest.h>
#include <tencentcloud/tdmq/v20200217/model/SendBatchMessagesResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 批量发送消息示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    SendBatchMessagesRequest req = SendBatchMessagesRequest();
    // 设置已授权角色密钥
    req.SetStringToken("eyJrZXlJZCI......");
    // 设置已授权角色名称
    req.SetProducerName("admin");
    // 设置topic名称, 格式为: 集群（租户）ID/命名空间/Topic名称
    req.SetTopic("pulsar-xxx/cpp_http/topic1");
    // 消息内容
    req.SetPayload("this is a new message.");
    // 设置发送超时时间
    req.SetSendTimeout(3000);
    // 设置内存中允许缓存的生产消息的最大数量
    req.SetMaxPendingMessages(100);
    // 设置每一个batch中消息的最大数量
    req.SetBatchingMaxMessages(100);
    // 设置每一个batch最大等待的时间，超过这个时间，不管是否达到指定的batch中消息的数量和大小，都会将该batch发送出去，
    req.SetBatchingMaxPublishDelay(100);
    // 设置每一个batch中最大允许的消息的大小
    req.SetBatchingMaxBytes(100);
    // 发送消息
    auto outcome = client.SendBatchMessages(req);
    if (!outcome.IsSuccess())
    {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    SendBatchMessagesResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}