#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/SendMessagesRequest.h>
#include <tencentcloud/tdmq/v20200217/model/SendMessagesResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 发送消息示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    SendMessagesRequest req = SendMessagesRequest();
    // 设置已授权角色密钥
    req.SetStringToken("eyJrZXlJZCI......");
    // 设置已授权角色名称
    req.SetProducerName("admin");
    // 设置topic名称, 格式为: 集群（租户）ID/命名空间/Topic名称
    req.SetTopic("pulsar-xxx/cpp_http/topic1");
    // 消息内容
    req.SetPayload("this is a new message.");
    // 设置发送消息超时时间
    req.SetSendTimeout(3000);
    // 发送消息
    auto outcome = client.SendMessages(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    SendMessagesResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}