
#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/CreateSubscriptionRequest.h>
#include <tencentcloud/tdmq/v20200217/model/CreateSubscriptionResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 创建订阅示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    CreateSubscriptionRequest req = CreateSubscriptionRequest();
    // 设置集群id
    req.SetClusterId("pulsar-xxxx");
    // 设置命名空间名称
    req.SetEnvironmentId("cpp_http");
    // 设置topic名称
    req.SetTopicName("topic1");
    // 设置订阅名称
    req.SetSubscriptionName("sub");
    // 设置订阅信息
    req.SetRemark("订阅信息");
    // 是否幂等创建，若否不允许创建同名的订阅关系。
    req.SetIsIdempotent(true);
    // 是否自动创建死信和重试主题，True 表示创建，False表示不创建，默认自动创建死信和重试主题。
    req.SetAutoCreatePolicyTopic(false);
    // 指定死信和重试主题名称规范，LEGACY表示历史命名规则，COMMUNITY表示Pulsar社区命名规范
    req.SetPostFixPattern("COMMUNITY");
    // 创建订阅信息
    auto outcome = client.CreateSubscription(req);
    if (!outcome.IsSuccess())
    {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    CreateSubscriptionResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}