
#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/DeleteSubscriptionsRequest.h>
#include <tencentcloud/tdmq/v20200217/model/DeleteSubscriptionsResponse.h>
#include <iostream>
#include <string>
#include <vector>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 删除订阅信息
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");
    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    DeleteSubscriptionsRequest req = DeleteSubscriptionsRequest();
    // 创建要删除的订阅实例
    SubscriptionTopic subscriptionTopic1;
    // 设置命名空间名称
    subscriptionTopic1.SetEnvironmentId("cpp_http");
    // 设置topic名称
    subscriptionTopic1.SetTopicName("topic1");
    // 设置订阅信息
    subscriptionTopic1.SetSubscriptionName("sub");
    vector<SubscriptionTopic> subscriptionTopics1 = {subscriptionTopic1};
    req.SetSubscriptionTopicSets(subscriptionTopics1);
    // 设置集群id
    req.SetClusterId("pulsar-xxx");
    // 设置强制删除
    req.SetForce(true);
    // 删除订阅信息
    auto outcome = client.DeleteSubscriptions(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取响应结果
    DeleteSubscriptionsResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}