#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/CreateTopicRequest.h>
#include <tencentcloud/tdmq/v20200217/model/CreateTopicResponse.h>
#include <iostream>
#include <string>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 创建topic示例
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    CreateTopicRequest req = CreateTopicRequest();
    // 设置集群id
    req.SetClusterId("pulsar-xxx");
    // 设置命名空间名称
    req.SetEnvironmentId("cpp_http");
    // 设置topic名称
    req.SetTopicName("topic1");
    // 设置topic分区数
    req.SetPartitions(3);
    // 设置topic说明信息
    req.SetRemark("topic说明");
    // 设置topic类型0： 普通消息； 1 ：全局顺序消息(设置全局顺序是，分区数要为0)； 2 ：局部顺序消息；
    req.SetTopicType(0);

    // 创建topic
    auto outcome = client.CreateTopic(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    CreateTopicResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}