#include <tencentcloud/core/Credential.h>
#include <tencentcloud/core/profile/ClientProfile.h>
#include <tencentcloud/core/profile/HttpProfile.h>
#include <tencentcloud/tdmq/v20200217/TdmqClient.h>
#include <tencentcloud/tdmq/v20200217/model/DeleteTopicsRequest.h>
#include <tencentcloud/tdmq/v20200217/model/DeleteTopicsResponse.h>
#include <iostream>
#include <string>
#include <vector>

using namespace TencentCloud;
using namespace TencentCloud::Tdmq::V20200217;
using namespace TencentCloud::Tdmq::V20200217::Model;
using namespace std;

/**
 * 删除topic示例
 * @return
 */
int main() {
    // 认证信息
    Credential cred = Credential("AKIDSiiRtxxxx", "GGzSeaM5xxxx");

    HttpProfile httpProfile = HttpProfile();
    httpProfile.SetEndpoint("tdmq.tencentcloudapi.com");

    ClientProfile clientProfile = ClientProfile();
    clientProfile.SetHttpProfile(httpProfile);
    // 创建tdmq客户端
    TdmqClient client = TdmqClient(cred, "ap-shanghai", clientProfile);

    DeleteTopicsRequest req = DeleteTopicsRequest();
    // 设置集群id
    req.SetClusterId("pulsar-xxx");
    // 创建要删除的topic实例
    TopicRecord topicRecord1;
    // 设置明明空间名称
    topicRecord1.SetEnvironmentId("cpp_http");
    // 设置topic名称
    topicRecord1.SetTopicName("topic1");
    vector<TopicRecord> topicRecords1 = {topicRecord1};
    req.SetTopicSets(topicRecords1);
    // 设置强制删除，会把topic的订阅信息一并删除，不设置时，如果存在订阅信息会导致删除失败
    req.SetForce(true);

    auto outcome = client.DeleteTopics(req);
    if (!outcome.IsSuccess()) {
        cout << outcome.GetError().PrintAll() << endl;
        return -1;
    }
    // 获取结果
    DeleteTopicsResponse resp = outcome.GetResult();
    cout << resp.ToJsonString() << endl;

    return 0;
}